from selenium import webdriver
from bs4 import BeautifulSoup
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import Select
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC

from chromedriver_py import binary_path
from selenium.webdriver.chrome.options import Options
import requests
import time
from datetime import date
from datetime import timedelta
import zipfile

import os.path
import os
import pandas as pd

def scraper(mode, version):
    
    baseurl = 'https://tenbou.nies.go.jp/download/'

    if mode == 'all':
        bdate = date(1971, 1, 1) #date(1960, 1, 1) # date before record starts
        edate = date.today()

        os.makedirs('/esarchive/obs/ghost/JAPAN_NIES/original_files/{}/'.format(version), exist_ok=True)

        download_location = '/esarchive/obs/ghost/JAPAN_NIES/original_files/{}/'.format(version)

    elif mode == 'nrt':
        bdate = date(2024, 3, 2) #date.today() - timedelta(days = 1) # if code is run after 2 am, data from previous day will be available
        edate = date(2024, 3, 3) #date.today() - timedelta(days = 1)
        download_location = '/esarchive/obs/ghost/JAPAN_NIES/original_files/{}/'.format(version)

    else:
        print('time mode inapplicable')


    # create date array, daily; format to YYYYMMDD
    years = pd.date_range(bdate, edate, freq='Y').strftime('%Y').tolist()

    options = Options()
    prefs = {'download.default_directory' : download_location}
    options.add_experimental_option('prefs', prefs)
    options.add_argument("--no-sandbox")
    #options.add_argument("--headless")
    svc = webdriver.ChromeService(executable_path=binary_path)
    driver = webdriver.Chrome(service=svc, options=options)

    driver.get(baseurl)
    time.sleep(2)

    # monthly/yearly data
    """
    # switch to monthly/yearly button
    tab = driver.find_element(By.ID, 'monthly_yearly_tab')
    driver.execute_script("arguments[0].setAttribute('class', 'nav-link active')", tab)
    time.sleep(2)

    search_button = driver.find_element(By.ID, 'my_search_button')
    driver.execute_script("arguments[0].click();", search_button)
    time.sleep(5)

    create_archive = driver.find_element(By.ID, 'my_create_archive')
    driver.execute_script("arguments[0].click();", create_archive)
    time.sleep(10)

    download_button = driver.find_element(By.ID, 'my_download_archive')
    driver.execute_script("arguments[0].click();", download_button)

    # wait until download finished
    time.sleep(3)
    #filename = os.listdir(download_location.format(version))[0]
    filename = [file for file in os.listdir(download_location.format(version)) if os.path.isfile(os.path.join(download_location.format(version), file))][0]
    filename = str(filename[:-11]) # cut out crdownload 

    # create monthly folder
    os.makedirs('/esarchive/obs/ghost/JAPAN_NIES/original_files/{}/'.format(version)+'monthly/', exist_ok=True)

    while not os.path.exists(download_location.format(version)+filename):
        time.sleep(1)

        if os.path.isfile(download_location.format(version)+filename):
            print('{} download successful'.format("monthly/yearly data"))

            # unzip
            with zipfile.ZipFile(download_location.format(version)+filename, 'r') as zip_ref:
                zip_ref.extractall(download_location.format(version)+'monthly/')
    
    os.remove(download_location.format(version)+filename)

    # sort files
    monthly_files = os.listdir(download_location.format(version)+'monthly/')

    for year in years:
        os.makedirs('/esarchive/obs/ghost/JAPAN_NIES/original_files/{}/'.format(version)+'monthly/'+year+'/', exist_ok=True)
        for file in monthly_files:
            if year in file[:6]:
                # unzip again
                with zipfile.ZipFile(download_location.format(version)+'monthly/{}'.format(file), 'r') as zip_ref:
                    zip_ref.extractall(download_location.format(version)+'monthly/{}/{}.txt'.format(year, file[:-4]))
                os.remove(download_location.format(version)+'monthly/{}'.format(file))"""

    
    # switch to time value tab
    print(dir(driver))
    click_on_tab = driver.find_element(By.LINK_TEXT, 'time value data')
    print(click_on_tab)

    """tab = driver.find_element(By.ID, 'time_tab')
    print(tab)
    driver.execute_script("arguments[0].removeAttribute('class')", tab)
    driver.execute_script("arguments[0].setAttribute('class', 'nav-link active')", tab)

    tab = driver.find_element(By.ID, 'monthly-yearly-panel')
    print(tab)
    driver.execute_script("arguments[0].removeAttribute('class')", tab)
    driver.execute_script("arguments[0].setAttribute('class', 'tab-pane fade')", tab)"""


    #driver.refresh()
    #driver.find_element(By.TAG_NAME, 'time value data').click()

    #driver.find_element(By.XPATH("//font[@text='time value data')]")).click()
    
    WebDriverWait(driver, 60).until(EC.presence_of_element_located((By.ID, 't_search_button'))) # wait till loaded

    search_button = driver.find_element(By.ID, 't_search_button')
    driver.execute_script("arguments[0].click();", search_button)
    
    WebDriverWait(driver, 60).until(EC.presence_of_element_located((By.ID, 't_create_archive'))) # wait till loaded

    create_archive = driver.find_element(By.ID, 't_create_archive')
    driver.execute_script("arguments[0].click();", create_archive)
    
    WebDriverWait(driver, 60).until(EC.presence_of_element_located((By.ID, 't_download_archive'))) # wait till loaded

    download_button = driver.find_element(By.ID, 't_download_archive')
    driver.execute_script("arguments[0].click();", download_button)

    os.makedirs('/esarchive/obs/ghost/JAPAN_NIES/original_files/{}/'.format(version)+'hourly/', exist_ok=True)

    # wait until download finished
    time.sleep(30)
    filename = [file for file in os.listdir(download_location.format(version)) if os.path.isfile(os.path.join(download_location.format(version), file))]
    print(filename)
    filename = str(filename[:-11]) # cut out crdownload
    print(filename)

    """while not os.path.exists(download_location.format(version)+filename):
        time.sleep(1)

        if os.path.isfile(download_location.format(version)+filename):
            print('{} download successful'.format("hourly data"))

            # unzip
            with zipfile.ZipFile(download_location.format(version)+filename, 'r') as zip_ref:
                zip_ref.extractall(download_location.format(version)+'hourly/')
    
    os.remove(download_location.format(version)+filename)"""

    """
    # switch to national buereau
    tab = driver.find_element(By.ID, 'time_gov_tab')
    driver.execute_script("arguments[0].setAttribute('class', 'nav-link active')", tab)
    time.sleep(2)

    search_button = driver.find_element(By.ID, 'tg_search_button')
    driver.execute_script("arguments[0].click();", search_button)
    time.sleep(5)

    create_archive = driver.find_element(By.ID, 'tg_create_archive')
    driver.execute_script("arguments[0].click();", create_archive)
    time.sleep(10)

    download_button = driver.find_element(By.ID, 'tg_download_archive')
    driver.execute_script("arguments[0].click();", download_button)

    # wait until download finished
    while not os.path.exists("{}/detail_{}.zip".format(download_location+COUNTRIES[i], today)):
        time.sleep(1)

        if os.path.isfile("{}/detail_{}.zip".format(download_location, today)):
            print('{} download successful'.format(country))


    time.sleep(5)"""

    """# download
    i=0
    for country in countries:
        # create download directory
        os.makedirs(download_location+COUNTRIES[i]+'/', exist_ok=True)

        dropdown_element = driver.find_element(By.ID, 'countryCd')
        select = Select(dropdown_element)
        select.select_by_visible_text(country)
        
        print("successfully selected {}".format(country))

        # start download
        driver.find_element(By.CSS_SELECTOR, "input[id='downloadBtn'][type='button']").click()

        # wait until download finished
        while not os.path.exists("{}/detail_{}.zip".format(download_location+COUNTRIES[i], today)):
            time.sleep(1)

            if os.path.isfile("{}/detail_{}.zip".format(download_location, today)):
                print('{} download successful'.format(country))

                # move to country directory
                os.rename("{}/detail_{}.zip".format(download_location, today), "{}/detail_{}.zip".format(download_location+COUNTRIES[i], today))

                # unzip
                with zipfile.ZipFile("{}/detail_{}.zip".format(download_location+COUNTRIES[i], today), 'r') as zip_ref:
                    zip_ref.extractall(os.path.dirname("{}/detail_{}.zip".format(download_location+COUNTRIES[i], today)))


        os.remove("{}/detail_{}.zip".format(download_location+COUNTRIES[i], today))

        i=i+1"""

    driver.close()