from selenium import webdriver
from bs4 import BeautifulSoup
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
import requests

import time
import pandas
from datetime import date
from datetime import timedelta
import os.path
import urllib
import pandas as pd


def scraper(mode, version):

    base_url = 'https://uk-air.defra.gov.uk/data/atom-dls/'

    if mode == 'all':
        bdate = date(2023, 1, 1) #date(1960, 1, 1) # date before record starts
        edate = date.today() + timedelta(days = 365)

        os.makedirs('/esarchive/obs/ghost/UK_AIR/original_files/{}/'.format(version), exist_ok=True)

        download_location = '/esarchive/obs/ghost/UK_AIR/original_files/{}/'.format(version)

    elif mode == 'nrt':
        version = mode
        bdate = date.today() 
        edate = date.today() + timedelta(days = 365)
        download_location = '/esarchive/obs/ghost/UK_AIR/original_files/nrt/'

    else:
        print('time mode inapplicable')


    # create date array, daily; format YYYYMMDD
    years = pandas.date_range(bdate, edate, freq='Y').strftime('%Y').tolist()
    download_feeds = ['auto', 'non-auto', 'aggregated']


    Headers = {'User-Agent': 'Mozilla/5.0 (iPad; CPU OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'}


    # download
    for download_feed in download_feeds:

        os.makedirs('/esarchive/obs/ghost/UK_AIR/original_files/{}/{}/'.format(version, download_feed), exist_ok=True)

        for year in years:
            url = '{}/{}/{}/atom.en.xml'.format(base_url, download_feed, year)
            r = requests.get(url, timeout=120, headers=Headers)

            if r.status_code == 200:
                with open(os.path.join(download_location, download_feed, download_feed+year+'.xml'), 'wb') as file:
                    file.write(r.content)
                print('Downloaded {} {}'.format(download_feed, year))
            else:
                print('No {} {}'.format(download_feed, year))

            time.sleep(1)